//havok_config.h
#ifndef _HAVOK_CONFIG_H
#define _HAVOK_CONFIG_H

#include <windows.h>
#include <stdio.h>
#include <assert.h>
#include <d3d9.h>
#include <d3dx9.h>


//#define HK_CONFIG_SIMD	2

#include <Common/Base/hkBase.h>
#include <Common/Base/Container/String/hkStringBuf.h>
#include <Common/Base/Ext/hkBaseExt.h>
#include <Common/Base/Memory/System/Util/hkMemoryInitUtil.h>
#include <Common/Base/Memory/Allocator/Malloc/hkMallocAllocator.h>

#include <Physics/Dynamics/World/hkpWorld.h>
#include <Physics/Dynamics/Entity/hkpRigidBody.h>
#include <Physics/Dynamics/Entity/hkpRigidBodyCinfo.h>
#include <Physics/Utilities/Dynamics/Inertia/hkpInertiaTensorComputer.h>
#include <Physics/Collide/Shape/Convex/Box/hkpBoxShape.h>
#include <Physics/Collide/Shape/Convex/Sphere/hkpSphereShape.h>
#include <Physics/Collide/Dispatch/hkpAgentRegisterUtil.h>
#include <Physics/Collide/Filter/Group/hkpGroupFilter.h>


//  
#include <Common/Visualize/hkVisualDebugger.h>
#include <Physics/Utilities/VisualDebugger/hkpPhysicsContext.h>	


//Ƽ 
//#define  USE_MULTITHREAD   1
#ifdef USE_MULTITHREAD
#include <Common/Base/Thread/Job/ThreadPool/Cpu/hkCpuJobThreadPool.h>
#include <Common/Base/Thread/Job/ThreadPool/Spu/hkSpuJobThreadPool.h>
#include <Common/Base/Thread/JobQueue/hkJobQueue.h>
#endif


//------------------------------------------------------------------------------------
//
// ʹ Ϻ õ Լ ߰Ѵ.
//
//------------------------------------------------------------------------------------

enum
{
	KEYFRAME_LAYER = 1,
	BACKGROUND_LAYER = 2,
	STATIC_LAYER = 3,
	SPHERE_LAYER = 4,
};

#define UID_WALL_PROPERTY 0x100000 


void HavokErrorReportFunction(const char* s, void* errorReportObject) ;
bool MakeGround( hkpWorld* pWorld );
bool MakeBox( hkpWorld* pWorld );
hkpRigidBody* AddKeyFrameBox( hkpWorld* pWorld , const hkVector4* position, const hkVector4*  width );
hkpRigidBody* AddDynamicShere( hkpWorld* pWorld , const hkVector4& position, float fRadius );

void CheckContactPoint( hkpWorld* pWorld, hkpRigidBody* pRigidBody, hkArray<hkContactPoint>& outPoint );

void SetEnableCollisionStaticBox( hkpWorld* pWorld , bool bFlag );

extern const float g_groundHalfHeight;
extern hkpRigidBody* g_groundBody;

extern const float g_bx, g_by, g_bz;
extern const int g_nx, g_ny, g_nz;
extern const int g_NUM_BODIES;
extern hkpRigidBody* g_bodies[];
extern hkpRigidBody* g_sphereBody;
extern hkArray<hkContactPoint>		g_wallPoint;
extern bool	 g_bStopBall;

void RestartBall( hkpWorld* pWorld, float x, float y, float z );

#endif