//MeshObj.cpp
#include "MeshObj.h"
#include <iostream>

const char* obj_database = "";	

#pragma warning(disable:4786)	// microsoft stupid bug!!

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

mesh::mesh()
{
	scene = NULL;
	texture = NULL;
	matTotal = 0;		// mat[0] reserved for default meterial
	vTotal = tTotal = nTotal = fTotal = 0;
}

mesh::~mesh()
{
}

bool mesh::LoadMesh( std::string obj_file )
{
	char	token[100], buf[100], v[5][100];	
	float	vec[3];

	int	n_vertex, n_texture, n_normal;
	int	cur_tex = 0;				

	errno_t err = fopen_s( &scene, obj_file.c_str(), "rb");
	if( err != 0 )
		return false;

	s_file = obj_file;

	if (!scene) 
	{
		std::cout << std::string("Can not open object File \"") << obj_file << "\" !" << std::endl;
		return false;
	}

	//std::cout << std::endl << obj_file << std::endl;
		
	while(!feof(scene))
	{
		memset( token, 0, 100 );
		fscanf_s(scene,"%s", token, 100);		

		if (!strcmp(token,"g"))
		{
			fscanf_s(scene,"%s",buf, 100);
		}
		else if (!strcmp(token,"mtllib"))
		{
  			fscanf_s(scene,"%s", mat_file, 50);
			LoadTex( std::string( obj_database) + std::string( mat_file));
		}
		else if (!strcmp(token,"usemtl"))
		{
			fscanf_s( scene,"%s", buf, 100);
			cur_tex = matMap[s_file + std::string("_") + std::string( buf)];
		}
		else if (!strcmp(token,"v"))
		{
			fscanf_s( scene,"%f %f %f", &vec[0], &vec[1], &vec[2]);
			vList.push_back(Vec3(vec));
		}
		else if (!strcmp(token,"vn"))
		{
			fscanf_s(scene,"%f %f %f",&vec[0],&vec[1],&vec[2]);
			nList.push_back(Vec3(vec));
		}
		else if (!strcmp(token,"vt"))
		{
			fscanf_s(scene,"%f %f",&vec[0],&vec[1]);
			tList.push_back(Vec2(vec));
		}
		else if (!strcmp(token,"f"))
		{
			int i = 0;
			for ( i=0; i<3; i++)		// face 
			{
				fscanf_s(scene,"%s",v[i], 100);
				//printf("[%s]",v[i]);
			}
			//printf("\n");
		  
			Vertex	tmp_vertex[3];		// for faceList structure

			for ( i=0; i<3; i++)		// for each vertex of this face
			{
				char str[20], ch;
				int base,offset;
				base = offset = 0;

				// calculate vertex-list index
				while( (ch=v[i][base+offset]) != '/' && (ch=v[i][base+offset]) != '\0')
				{
					str[offset] = ch;
					offset++;
				}
				str[offset] = '\0';
				n_vertex = atoi(str);
				base += (ch == '\0')? offset : offset+1;
				offset = 0;

				// calculate texture-list index
				while( (ch=v[i][base+offset]) != '/' && (ch=v[i][base+offset]) != '\0')
				{
					str[offset] = ch;
					offset++;
				}
				str[offset] = '\0';
				n_texture = atoi(str);	// case: xxx//zzz
				base += (ch == '\0')? offset : offset+1;
				offset = 0;

				// calculate normal-list index
				while( (ch=v[i][base+offset]) != '\0')
				{
					str[offset] = ch;
					offset++;
				}
				str[offset] = '\0';
				n_normal = atoi(str);	// case: xxx/yyy

				tmp_vertex[i].v = n_vertex;
				tmp_vertex[i].t = n_texture;
				tmp_vertex[i].n = n_normal;
				tmp_vertex[i].m = cur_tex;
			}

			faceList.push_back(FACE(tmp_vertex[0],tmp_vertex[1],tmp_vertex[2]));
		}
		else if (!strcmp(token,"#"))	 
			fgets(buf,100,scene);

//		printf("[%s]\n",token);
	}

	if (scene) fclose(scene);

	vTotal = (int)vList.size();
	nTotal = (int)nList.size();
	tTotal = (int)tList.size();
	fTotal = (int)faceList.size();
	//printf("vetex: %d, normal: %d, texture: %d, triangles: %d\n",vTotal, nTotal, tTotal, fTotal);
	return true;
}

#if  0
//̷Ʈ X  MeshFromOBJ 
#include <fstream>
void mesh::LoadTex( std::string tex_file)
{
	int cur_mat;
	char	buf[100];
	float	r, g, b;			

	std::ifstream inFile( tex_file.c_str() );
	if (!inFile) 
	{
		std::cout << "Can't open material file \"" << tex_file << "\"!" << std::endl;
		return;
	}

	char token[256] = {0};

	for( ; ; )
	{
        inFile >> token;
        if( !inFile )
            break;

		if (!strcmp(token,"newmtl"))
		{
			inFile >> buf;
			cur_mat = matTotal++;					
			matMap[s_file + std::string("_") + std::string(buf)] = cur_mat; // matMap["material_name"] = material_id;
		}
		else if (!strcmp(token,"Ka"))
		{
			inFile >> r >> g >> b;
			mat[cur_mat].Ka[0] = r;
			mat[cur_mat].Ka[1] = g;
			mat[cur_mat].Ka[2] = b;
			mat[cur_mat].Ka[3] = 1;
		}
		else if (!strcmp(token,"Kd"))
		{
			inFile >> r >> g >> b;
			mat[cur_mat].Kd[0] = r;
			mat[cur_mat].Kd[1] = g;
			mat[cur_mat].Kd[2] = b;
			mat[cur_mat].Kd[3] = 1;
		}
		else if (!strcmp(token,"Ks"))
		{
			inFile >> r >> g >> b;
			mat[cur_mat].Ks[0] = r;
			mat[cur_mat].Ks[1] = g;
			mat[cur_mat].Ks[2] = b;
			mat[cur_mat].Ks[3] = 1;
		}
		else if (!strcmp(token,"Ns"))
		{
			inFile >> r;
			mat[cur_mat].Ns = r;
		}
		else if (!strcmp(token, "map_Kd"))  //ǻ Į ؽ 
		{
			inFile >> buf;
			mat[cur_mat].map_Kd = buf;
		}
		else if (!strcmp(token,"#"))	
		{
			//ϳ ڿ "#"϶ infFile >> buff ع  ڿ ignore() ϱ 
			//⼭ ó ʴ´.
		}

		inFile.ignore( 1000, '\n' );
//		printf("[%s]\n",token);
	}

	//printf("total material:%d\n",matMap.size());

	inFile.close();

}
#else
void mesh::LoadTex( std::string tex_file)
{
	char	token[100], buf[100];
	float	r, g, b;			

	errno_t err = fopen_s( &texture, tex_file.c_str(),"r");
	t_file = tex_file;

	if (!texture) 
	{
		std::cout << "Can't open material file \"" << tex_file << "\"!" << std::endl;
		return;
	}

	std::cout << tex_file << std::endl;

	int cur_mat;

	while(!feof(texture))
	{
		token[0] = NULL;
		fscanf_s(texture,"%s", token, 100);	

		if (!strcmp(token,"newmtl"))
		{
			fscanf_s(texture,"%s", buf, 100);
			cur_mat = matTotal++;					
			matMap[s_file + std::string("_") + std::string(buf)] = cur_mat; // matMap["material_name"] = material_id;
		}
		else if (!strcmp(token,"Ka"))
		{
			fscanf_s(texture,"%f %f %f",&r,&g,&b);
			mat[cur_mat].Ka[0] = r;
			mat[cur_mat].Ka[1] = g;
			mat[cur_mat].Ka[2] = b;
			mat[cur_mat].Ka[3] = 1;
		}
		else if (!strcmp(token,"Kd"))
		{
			fscanf_s(texture,"%f %f %f",&r,&g,&b);
			mat[cur_mat].Kd[0] = r;
			mat[cur_mat].Kd[1] = g;
			mat[cur_mat].Kd[2] = b;
			mat[cur_mat].Kd[3] = 1;
		}
		else if (!strcmp(token,"Ks"))
		{
			fscanf_s(texture,"%f %f %f",&r,&g,&b);
			mat[cur_mat].Ks[0] = r;
			mat[cur_mat].Ks[1] = g;
			mat[cur_mat].Ks[2] = b;
			mat[cur_mat].Ks[3] = 1;
		}
		else if (!strcmp(token,"Ns"))
		{
			fscanf_s(texture,"%f",&r);
			mat[cur_mat].Ns = r;
		}
		else if (!strcmp(token, "map_Kd"))  //ǻ Į ؽ 
		{
			fscanf_s(texture,"%s", buf, 100);
			mat[cur_mat].map_Kd = buf;
		}
		else if (!strcmp(token,"#"))	 
			fgets(buf,100,texture);

//		printf("[%s]\n",token);
	}

	//printf("total material:%d\n",matMap.size());

	if (texture) fclose(texture);
}
#endif

bool mesh::open(const char* objFileName )
{
	float default_value[3] = {1,1,1};

	vList.push_back(Vec3(default_value));	
	nList.push_back(Vec3(default_value));	
	tList.push_back(Vec2(default_value));

	mat[0].Ka[0] = 0.0f; mat[0].Ka[1] = 0.0f; mat[0].Ka[2] = 0.0f; mat[0].Ka[3] = 1.0f; 
	mat[0].Kd[0] = 1.0f; mat[0].Kd[1] = 1.0f; mat[0].Kd[2] = 1.0f; mat[0].Kd[3] = 1.0f; 
	mat[0].Ks[0] = 0.8f; mat[0].Ks[1] = 0.8f; mat[0].Ks[2] = 0.8f; mat[0].Ks[3] = 1.0f;
	mat[0].Ns = 32;
	matTotal++;

	return LoadMesh( std::string( objFileName ));		
}

